-- TAD Árbol Binario

module TADArbol (Arbol, vacíoA, nodoA, es_vacíoA, raízA, izqA, derA, hojaA, alturaA, posA, puntoA, flechaA) where

import TADNatural
import TADLista
import TADConjunto
import TADDirectiva

-- CONSTRUCTORES

data Arbol e = Vacío | Nodo (Arbol e) e (Arbol e)
             deriving (Show, Eq)

-- ECUACIONES ENTRE CONSTRUCTORES
-- no hay

vacíoA = Vacío
nodoA = Nodo

-- OPERACIONES

es_vacíoA :: Arbol e -> Bool
raízA :: Arbol e -> e -- sólo se aplica a árboles no vacíos
izqA :: Arbol e -> Arbol e -- sólo se aplica a árboles no vacíos
derA :: Arbol e -> Arbol e -- sólo se aplica a árboles no vacíos
hojaA :: e -> Arbol e
alturaA :: Arbol e -> Natural
posA :: Arbol e -> Conjunto (Lista Directiva)
puntoA :: Arbol e -> Lista Directiva -> e -- sólo se aplica a listas de directivas que no se escapan del árbol
flechaA :: Arbol e -> Lista Directiva -> Arbol e
es_abb :: Ord e => Arbol e -> Bool

-- ECUACIONES

es_vacíoA Vacío = True
es_vacíoA _ = False

raízA (Nodo i r d) = r
izqA (Nodo i r d) = i
derA (Nodo i r d) = d

hojaA e = Nodo Vacío e Vacío

alturaA Vacío = cero
alturaA (Nodo i _ d) = suc (alturaA i `max` alturaA d)

posA Vacío = vacíoC
posA (Nodo i r d) = singC vacíaL `unionC` imagenC (consL irIzq) (posA i) `unionC` imagenC (consL irDer) (posA d)

Nodo i r d `puntoA` dirs | es_vacíaL dirs = r
                         | cabezaL dirs == irIzq = i `puntoA` colaL dirs
                         | cabezaL dirs == irDer = d `puntoA` colaL dirs

Vacío `flechaA` _ = Vacío
a@(Nodo i _ d) `flechaA` dirs | es_vacíaL dirs = a
                              | cabezaL dirs == irIzq = i `flechaA` colaL dirs
                              | cabezaL dirs == irDer = d `flechaA` colaL dirs

maximo :: Ord e => Arbol e -> e -- se aplica a ABBs no vacíos
maximo (Nodo i r Vacío) = r
maximo (Nodo i r d) = maximo d

minimo :: Ord e => Arbol e -> e -- se aplica a ABBs no vacíos
minimo (Nodo Vacío r d) = r
minimo (Nodo i r d) = minimo i

es_abb Vacío = True
es_abb (Nodo Vacío r Vacío) = True
es_abb (Nodo Vacío r d) = es_abb d && r < minimo d
es_abb (Nodo i r Vacío) = es_abb i && maximo i < r
es_abb (Nodo i r d) = es_abb i && es_abb d && maximo i < r && r < minimo d


