-- TAD Diccionario

module TADDiccionario (Diccionario, vacíoD, consD, es_vacíoD, elemD, defD, elimD, elemsD) where

import TADConjunto

-- CONSTRUCTORES

data Diccionario e f = Vacío | Cons e f (Diccionario e f)
                     deriving Show

-- ECUACIONES ENTRE CONSTRUCTORES
-- Cons e f (Cons e h d) == Cons e f d
-- si e /= f entonces Cons e f (Cons g h d) == Cons g h (Cons e f d)

vacíoD = Vacío
consD = Cons

-- OPERACIONES

es_vacíoD :: Diccionario e d -> Bool
elemD :: Eq e => e -> Diccionario e d -> Bool
defD :: Eq e => e -> Diccionario e d -> d
-- defD se aplica solamente cuando el elemento está en el diccionario
elimD :: Eq e => e -> Diccionario e d -> Diccionario e d
elemsD :: Diccionario e d -> Conjunto e

-- ECUACIONES

es_vacíoD Vacío = True
es_vacíoD _ = False

e `elemD` Vacío = False
e `elemD` Cons f g d = e == f || e `elemD` d

e `defD` Cons f g d | e == f = g
                    | otherwise = e `defD` d

e `elimD` Vacío = Vacío
e `elimD` Cons f g d | e == f = e `elimD` d
                     | otherwise = Cons f g (e `elimD` d)

elemsD Vacío = vacíoC
elemsD (Cons f g d) = consC f (elemsD d)

instance (Eq e, Eq f) => Eq (Diccionario e f) where
  c == d = elemsD c == elemsD d &&
           paratodoC (\e -> e `defD` c == e `defD` d) (elemsD c)


