-- TAD Diccionario

module TADDiccionario (Diccionario, vacíoD, consD, es_vacíoD, elemD, defD, elimD, elemsD) where

import TADConjunto
import TADArbol

-- CONSTRUCTORES

type Diccionario e d = Arbol (e,d)

vacíoD = vacíoA
consD e f abb | es_vacíoA abb = hojaA (e,f)
              | e < fst (raízA abb) = nodoA (consD e f (izqA abb))
                                           (raízA abb)
                                           (derA abb)
              | e > fst (raízA abb) = nodoA (izqA abb)
                                           (raízA abb)
                                           (consD e f (derA abb))
              | otherwise = nodoA (izqA abb)
                                  (e,f)
                                  (derA abb)

-- OPERACIONES

es_vacíoD :: Diccionario e d -> Bool
elemD :: Ord e => e -> Diccionario e d -> Bool
defD :: Ord e => e -> Diccionario e d -> d
-- defD se aplica solamente cuando el elemento está en el diccionario
elimD :: Ord e => e -> Diccionario e d -> Diccionario e d
elemsD :: Diccionario e d -> Conjunto e

-- ECUACIONES

es_vacíoD abb = es_vacíoA abb

e `elemD` abb | es_vacíoA abb = False
              | e < fst (raízA abb) = e `elemD` izqA abb
              | e > fst (raízA abb) = e `elemD` derA abb
              | otherwise = True

e `defD` abb | e < fst (raízA abb) = e `defD` izqA abb
             | e > fst (raízA abb) = e `defD` derA abb
             | otherwise = snd (raízA abb)

e `elimD` abb | es_vacíoA abb = vacíoD
              | e < fst (raízA abb) = nodoA (e `elimD` izqA abb)
                                            (raízA abb)
                                            (derA abb)
              | e > fst (raízA abb) = nodoA (izqA abb)
                                            (raízA abb)
                                            (e `elimD` derA abb)
              | e == fst (raízA abb) && es_vacíoA (izqA abb) = derA abb
              | otherwise = nodoA (elimMaxi (izqA abb))
                                  (maxi (izqA abb))
                                  (derA abb)

maxi :: Arbol (e,d) -> (e,d)
-- se aplica a ább no vacío
maxi abb | es_vacíoA (derA abb) = raízA abb
         | otherwise = maxi (derA abb)

elimMaxi :: Arbol a -> Arbol a
-- se aplica a ább no vacío
elimMaxi abb | es_vacíoA (derA abb) = izqA abb
             | otherwise = nodoA (izqA abb)
                                 (raízA abb)
                                 (elimMaxi (derA abb))

elemsD abb | es_vacíoA abb = vacíoC
           | otherwise = elemsD (izqA abb) `unionC` singC (fst (raízA abb))
                                           `unionC` elemsD (derA abb)

--instance (Eq e, Eq f) => Eq (Diccionario e f) where
--  c == d = elemsD c == elemsD d &&
--           paratodoC (\e -> e `defD` c == e `defD` d) (elemsD c)


